Hdu 4081 最小生成树

Qin Shi Huang's National Road System

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 6137    Accepted Submission(s): 2143


Problem Description
During the Warring States Period of ancient China(476 BC to 221 BC), there were seven kingdoms in China ---- they were Qi, Chu, Yan, Han, Zhao, Wei and Qin. Ying Zheng was the king of the kingdom Qin. Through 9 years of wars, he finally conquered all six other kingdoms and became the first emperor of a unified China in 221 BC. That was Qin dynasty ---- the first imperial dynasty of China(not to be confused with the Qing Dynasty, the last dynasty of China). So Ying Zheng named himself "Qin Shi Huang" because "Shi Huang" means "the first emperor" in Chinese.

Qin Shi Huang undertook gigantic projects, including the first version of the Great Wall of China, the now famous city-sized mausoleum guarded by a life-sized Terracotta Army, and a massive national road system. There is a story about the road system:
There were n cities in China and Qin Shi Huang wanted them all be connected by n-1 roads, in order that he could go to every city from the capital city Xianyang.
Although Qin Shi Huang was a tyrant, he wanted the total length of all roads to be minimum,so that the road system may not cost too many people's life. A daoshi (some kind of monk) named Xu Fu told Qin Shi Huang that he could build a road by magic and that magic road would cost no money and no labor. But Xu Fu could only build ONE magic road for Qin Shi Huang. So Qin Shi Huang had to decide where to build the magic road. Qin Shi Huang wanted the total length of all none magic roads to be as small as possible, but Xu Fu wanted the magic road to benefit as many people as possible ---- So Qin Shi Huang decided that the value of A/B (the ratio of A to B) must be the maximum, which A is the total population of the two cites connected by the magic road, and B is the total length of none magic roads.
Would you help Qin Shi Huang?
A city can be considered as a point, and a road can be considered as a line segment connecting two points.
 
Input
The first line contains an integer t meaning that there are t test cases(t <= 10).
For each test case:
The first line is an integer n meaning that there are n cities(2 < n <= 1000).
Then n lines follow. Each line contains three integers X, Y and P ( 0 <= X, Y <= 1000, 0 < P < 100000). (X, Y) is the coordinate of a city and P is the population of that city.
It is guaranteed that each city has a distinct location.
 
Output
For each test case, print a line indicating the above mentioned maximum ratio A/B. The result should be rounded to 2 digits after decimal point.
 
Sample Input
2 4 1 1 20 1 2 30 200 2 80 200 1 100 3 1 1 20 1 2 30 2 2 40
 
Sample Output
65.00 70.00
 
Source

题意:给你n个点的坐标和每个城市的人数p,现在要修路,两点之间距离就是欧拉距离,要使得所有的n个城市都联通,且可以免费修一条路(u,v),求使得A =pu + pv,  B = 要修的其他路的总长度,  求A/B的最大值

因为要使得n个城市联通,那我们只需要修n-1条路,可以枚举免费修的路(u,v),只需要得出:包含边(u,v)的最小生成树mst(u,v)

如何得出包含边(u,v)的最小生成树呢?

我们先求一次原图的最小生成树MST,在该生成树上添加边(u,v),就会形成一个环,我们要做的就是在树中去掉u到v唯一路径上的最大边权

如何求出u到v唯一路径上的最大边呢?

mc[u][v]表示节点u到v路径上的最大边,用数组记录访问过的节点x, 有mc[v][x] = max(mc[v][u], mc[u][x])  其中u是v的父亲

在CF上有一题就是求包含每一条边的最小生成树,我们也可以在原图的最小生成树上用LCA预处理出fa[u][i]表示节点u到其第2^i个祖先的路径上的最大边权,每次可以log得出u到v的最大边

#include <bits/stdc++.h>
using namespace std;
const int N = 1005;
struct Edge {
    int u, v;
    double w;
    Edge() {}
    Edge(int u, int v, double w):u(u),v(v),w(w) {}
    friend bool operator < (Edge a, Edge b) {
        return a.w < b.w;
    }
};
Edge e[N * N * 2];
int x[N], y[N], fa[N];
int p[N];
vector<Edge> g[N];
double dist(int i, int j) {
    return sqrt((x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]) * 1.0);
}
int findx(int x) {
    return fa[x] == x ? x:fa[x] = findx(fa[x]);
}
double MST(int m, int n) {
    for(int i = 0; i < n; ++i) fa[i] = i;
    sort(e, e + m);
    double ans = 0;
    int num = 0;
    for(int i = 0; i < m; ++i)
    {
        int fu = findx(e[i].u);
        int fv = findx(e[i].v);
        if(fu == fv) continue;
        num++;
        fa[fu] = fv;
        ans += e[i].w;
        g[e[i].u].push_back(Edge(-1,e[i].v, e[i].w));
        g[e[i].v].push_back(Edge(-1,e[i].u, e[i].w));
        if(num == n - 1) break;
    }
    return ans;
}
double mc[N][N];
int vis[N], cur[N], c;
void DFS(int u) {
    vis[u] = 1; cur[c++] = u;
    int sx = g[u].size();
    for(int i = 0; i < sx; ++i) {
        int v = g[u][i].v;
        double w = g[u][i].w;
        if(vis[v]) continue;
        for(int j = 0; j < c; ++j) {
            int x = cur[j];
            mc[v][x] = mc[x][v] = max(w, mc[x][u]);
        }
        DFS(v);
    }
}
double solve(int n, double B) {
    double ans = 0;
    for(int i = 0; i < n; ++i) {
        for(int j = i + 1; j < n; ++j)
        ans = max(ans, (p[i] + p[j]) * 1.0 / (B - mc[i][j]));
    }
    return ans;
}
int main()
{
    int _; scanf("%d", &_);
    while(_ --) {
        int n; scanf("%d", &n);
        for(int i = 0; i < n; ++i) g[i].clear();
        for(int i = 0; i < n; ++i) scanf("%d%d%d", &x[i], &y[i], &p[i]);
        int m = 0;
        for(int i = 0; i < n; ++i)
            for(int j = i + 1; j < n; ++j) {
            e[m++] = Edge(i, j, dist(i, j));
        }
      //  for(int i = 0; i < m; ++i) printf("%d %d %f
", e[i].u, e[i].v, e[i].w);
        c = 0;
        memset(mc, 0, sizeof mc);
        memset(vis, 0, sizeof vis);
        double res = MST(m, n);
        DFS(1);
        printf("%.2f
", solve(n, res));
    }
    return 0;
}
View Code
原文地址:https://www.cnblogs.com/orchidzjl/p/5314472.html